Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 468)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
@@ -4491,5 +5221,102 @@
       break;
     }
-
+    /////////////////////
+    case CLEANUP_IVT_LOCK_DATA://RWT
+    {
+    //Search for a matching inval in the UPT (there must be one) and check if there is a pending read.
+      if(r_alloc_ivt_fsm.read() == ALLOC_IVT_CLEANUP)
+      {
+        size_t index = 0;
+        bool   match_inval;
+
+        match_inval = m_upt.search_inval(r_cleanup_nline.read(), index);
+        assert (match_inval && "VCI MEM CACHE ERROR: In CLEANUP_IVT_LOCK_DATA, NO CORRESPONDING INVAL");
+        r_cleanup_read_srcid    = m_upt.srcid(index);
+        r_cleanup_read_trdid    = m_upt.trdid(index);
+        r_cleanup_read_pktid    = 0x0 + m_upt.pktid(index);
+        r_cleanup_read_need_rsp = !m_upt.need_rsp(index);
+        r_cleanup_index         = index;
+
+        r_cleanup_fsm = CLEANUP_IVT_CLEAR_DATA;
+      }
+#if DEBUG_MC_CLEANUP
+      if (m_debug)
+      {
+        std::cout
+            << " <MEMC " << name()
+            << " CLEANUP_IVT_LOCK_DATA> fetch pending inval"
+            << std::endl;
+      }
+#endif
+    break;
+    }
+
+    //////////////////////////
+    case CLEANUP_IVT_CLEAR_DATA://RWT
+    {
+      m_upt.clear(r_cleanup_index.read());
+      assert ((r_cleanup_read_need_rsp.read() == (r_read_to_cleanup_req.read() && (r_cleanup_nline.read() == r_read_to_cleanup_nline.read()))) && "condition pending read");
+      if (r_cleanup_read_need_rsp.read())
+      {
+        r_cleanup_fsm = CLEANUP_READ_RSP;
+      }
+      else
+      {
+        r_cleanup_fsm = CLEANUP_SEND_CLACK;
+      }
+#if DEBUG_MC_CLEANUP
+      if (m_debug)
+      {
+        std::cout
+            << " <MEMC " << name()
+            << " CLEANUP_IVT_CLEAR_DATA> clear UPT entry"
+            << std::endl;
+      }
+#endif
+    break;
+    }
+
+    ////////////////////////
+    case CLEANUP_READ_RSP://RWT
+    {
+      if(r_cleanup_to_tgt_rsp_req.read()) break;
+      
+      r_cleanup_to_tgt_rsp_req     = true;
+      r_cleanup_to_tgt_rsp_srcid   = r_cleanup_read_srcid.read();
+      r_cleanup_to_tgt_rsp_trdid   = r_cleanup_read_trdid.read();
+      r_cleanup_to_tgt_rsp_pktid   = 0x0 + r_cleanup_read_pktid.read();//WT
+      r_cleanup_to_tgt_rsp_type    = 0; //Read instruction
+      r_cleanup_to_tgt_rsp_length  = r_read_to_cleanup_length.read();
+      r_cleanup_to_tgt_rsp_first_word  = r_read_to_cleanup_first_word.read();
+      r_read_to_cleanup_req        = false;
+      m_cpt_ncc_to_cc_read ++;
+      if (r_cleanup_contains_data.read()) //L1 was dirty
+      {
+        for(size_t i = 0; i<m_words; i++)
+        {
+          r_cleanup_to_tgt_rsp_data[i] = r_cleanup_data[i].read();
+        }
+      }
+      else //the L2 data are up to date
+      {
+        for(size_t i = 0; i<m_words; i++)
+        {
+          r_cleanup_to_tgt_rsp_data[i] = r_cleanup_old_data[i].read();
+        }        
+      }
+
+      r_cleanup_fsm                = CLEANUP_SEND_CLACK;
+
+#if DEBUG_MC_CLEANUP
+      if (m_debug)
+      {
+        std::cout
+            << " <MEMC " << name()
+            << " CLEANUP_READ_RSP> answer READ"
+            << std::endl;
+      }
+#endif
+    break;
+    }
     //////////////////////
     case CLEANUP_HEAP_REQ:
@@ -4497,5 +5324,5 @@
       // get the lock to the HEAP directory
       if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP) break;
-
+ 
       r_cleanup_fsm = CLEANUP_HEAP_LOCK;
 
@@ -4509,4 +5336,5 @@
       }
 #endif
+      m_cpt_cleanup_fsm_n_heap_lock++;
       break;
     }
@@ -4568,6 +5396,7 @@
           << " / r_cleanup_copy_inst = " << r_cleanup_copy_inst.read() << std::endl
           << "heap_entry.owner.srcid = " << heap_entry.owner.srcid
-          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl;
+          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl
 /**/
+          << "nline = " << r_cleanup_nline << std::endl;
         exit(0);
       }
@@ -4587,7 +5416,7 @@
           << " / r_cleanup_copy_inst = " << r_cleanup_copy_inst.read() << std::endl
           << "heap_entry.owner.srcid = " << heap_entry.owner.srcid
-          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl;
+          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl
 /**/
-
+          << "nline = " << r_cleanup_nline << std::endl;
         exit(0);
       }
@@ -4595,4 +5424,5 @@
       DirectoryEntry dir_entry;
       dir_entry.valid          = true;
+      dir_entry.cache_coherent = true;
       dir_entry.is_cnt         = r_cleanup_is_cnt.read();
       dir_entry.dirty          = r_cleanup_dirty.read();
@@ -4652,4 +5482,5 @@
 
       m_cache_directory.write(set,way,dir_entry);
+
 
 #if DEBUG_MEMC_CLEANUP
@@ -4854,4 +5685,5 @@
                              // invalidate transaction matching the cleanup 
     {
+      m_cpt_cleanup_fsm_ivt_lock++;
       if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP) break;
 
@@ -4860,5 +5692,4 @@
 
       match_inval = m_ivt.search_inval(r_cleanup_nline.read(), index);
-
       if ( not match_inval )     // no pending inval
       {
@@ -4874,5 +5705,6 @@
           << std::endl;
 #endif
-          break;
+        m_cpt_cleanup_fsm_n_upt_lock++;
+        break;
       }
 
@@ -4914,4 +5746,5 @@
       m_ivt.decrement(r_cleanup_index.read(), count);
 
+
       if(count == 0)   // multi inval transaction completed
       {
@@ -4920,5 +5753,12 @@
       else             // multi inval transaction not completed
       {
-        r_cleanup_fsm = CLEANUP_SEND_CLACK ;
+        if (r_cleanup_ncc.read()) //need to put data to the XRAM
+        {
+          r_cleanup_fsm = CLEANUP_IXR_REQ;
+        }
+        else
+        {
+          r_cleanup_fsm = CLEANUP_SEND_CLACK;
+        }
       }
 
@@ -4950,4 +5790,5 @@
       if      ( r_cleanup_need_rsp.read() ) r_cleanup_fsm = CLEANUP_WRITE_RSP;
       else if ( r_cleanup_need_ack.read() ) r_cleanup_fsm = CLEANUP_CONFIG_ACK;
+      else if ( r_cleanup_ncc.read()      ) r_cleanup_fsm = CLEANUP_IXR_REQ;
       else                                  r_cleanup_fsm = CLEANUP_SEND_CLACK;
 
@@ -4971,6 +5812,14 @@
       r_cleanup_to_tgt_rsp_trdid   = r_cleanup_write_trdid.read();
       r_cleanup_to_tgt_rsp_pktid   = r_cleanup_write_pktid.read();
-
-      r_cleanup_fsm                = CLEANUP_SEND_CLACK;
+      r_cleanup_to_tgt_rsp_type    = true;
+
+      if (r_cleanup_ncc.read())
+      {
+        r_cleanup_fsm = CLEANUP_IXR_REQ;//need to put data to the XRAM
+      }
+      else
+      {
+        r_cleanup_fsm = CLEANUP_SEND_CLACK;
+      }
 
 #if DEBUG_MEMC_CLEANUP
@@ -5000,4 +5849,67 @@
       break;
     }
+
+    /////////////////////////
+    case CLEANUP_IXR_REQ:
+    {
+    
+      //Send a request to the ixr to write the data in the XRAM using the prereserved TRT entry
+      if (r_alloc_trt_fsm.read() == ALLOC_TRT_CLEANUP)
+      {
+        if(!r_cleanup_to_ixr_cmd_req.read())
+        {
+          size_t index = 0;
+          bool   hit   = m_trt.hit_write(r_cleanup_nline.read(), &index); 
+
+          assert (hit and "CLEANUP_IXR_REQ found no matching entry in TRT");
+
+            r_cleanup_to_ixr_cmd_req     = true;
+
+            for(size_t i = 0; i < m_words; i++){
+              r_cleanup_to_ixr_cmd_data[i]   = r_cleanup_data[i];
+            }
+
+            r_cleanup_to_ixr_cmd_srcid   = r_cleanup_srcid.read();
+            r_cleanup_to_ixr_cmd_trdid   = index;
+            r_cleanup_to_ixr_cmd_pktid   = r_cleanup_pktid.read();
+            r_cleanup_to_ixr_cmd_nline   = r_cleanup_nline.read();
+            r_cleanup_to_ixr_cmd_ncc_l1_dirty = r_cleanup_contains_data.read();
+            r_cleanup_fsm = CLEANUP_SEND_CLACK;
+#if DEBUG_MEMC_CLEANUP
+      if(m_debug)
+      {
+        std::cout
+            << "  <MEMC " << name()
+            << " CLEANUP_IXR_REQ>"
+            << " request send to IXR_CMD"
+            << std::endl;
+      }
+#endif
+        }
+        else
+        {
+            r_cleanup_fsm = CLEANUP_WAIT;
+#if DEBUG_MEMC_CLEANUP
+      if(m_debug)
+      {
+        std::cout
+            << "  <MEMC " << name()
+            << " CLEANUP_IXR_REQ>"
+            << " waiting completion of previous request"
+            << std::endl;
+      }
+#endif
+        }
+      }
+      break;
+    }
+
+    /////////////////////
+    case CLEANUP_WAIT :
+    {
+      r_cleanup_fsm = CLEANUP_IXR_REQ;
+      break;
+    }
+
     ////////////////////////
     case CLEANUP_SEND_CLACK:  // acknowledgement to a cleanup command
@@ -5102,4 +6014,5 @@
       {
         r_cas_fsm = CAS_DIR_LOCK;
+        m_cpt_cas_fsm_n_dir_lock++;
       }
 
@@ -5112,4 +6025,7 @@
       }
 #endif
+
+      m_cpt_cas_fsm_dir_lock++;
+
       break;
     }
@@ -5124,4 +6040,5 @@
 
         r_cas_is_cnt     = entry.is_cnt;
+        r_cas_coherent   = entry.cache_coherent;
         r_cas_dirty      = entry.dirty;
         r_cas_tag        = entry.tag;
@@ -5171,4 +6088,5 @@
       DirectoryEntry entry;
       entry.valid          = true;
+      entry.cache_coherent = r_cas_coherent.read();
       entry.is_cnt         = r_cas_is_cnt.read();
       entry.dirty          = true;
@@ -5238,5 +6156,11 @@
     {
       // The CAS is a success => sw access to the llsc_global_table
-      m_llsc_table.sw(m_cmd_cas_addr_fifo.read());
+      // BUG LLSC
+      addr_t      nline      = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
+      m_llsc_table.sw(nline);
+      //m_llsc_table.sw(m_cmd_cas_addr_fifo.read());
+          /**//*std::cout << "MEMCACHE : from proc " << m_cmd_cas_srcid_fifo.read()
+                        << " | @ " << std::hex << m_cmd_cas_addr_fifo.read()
+                        << " | WRITE (cas triggered)" << std::endl;*/
 
       // test coherence request
@@ -5355,5 +6279,9 @@
           << " / count = " << nb_copies << std::endl;
 #endif
-      }
+        m_cpt_cas_fsm_n_upt_lock++;
+      }
+
+      m_cpt_cas_fsm_upt_lock++;
+
       break;
     }
@@ -5386,5 +6314,9 @@
 #endif
         r_cas_fsm = CAS_UPT_REQ;
-      }
+        m_cpt_cas_fsm_n_heap_lock++;
+      }
+
+      m_cpt_cas_fsm_heap_lock++;
+
       break;
     }
@@ -5526,5 +6458,9 @@
           r_cas_fsm = CAS_WAIT;
         }
-      }
+        m_cpt_cas_fsm_n_trt_lock++;
+      }
+
+      m_cpt_cas_fsm_trt_lock++;
+
       break;
     }
@@ -5591,5 +6527,9 @@
           r_cas_fsm = CAS_WAIT;
         }
-      }
+        m_cpt_cas_fsm_n_upt_lock++;
+      }
+
+      m_cpt_cas_fsm_upt_lock++;
+
       break;
     }
@@ -5769,5 +6709,9 @@
           r_cas_fsm       = CAS_MISS_TRT_SET;
         }
-      }
+        m_cpt_cas_fsm_n_trt_lock++;
+      }
+
+      m_cpt_cas_fsm_trt_lock++;
+
       break;
     }
@@ -5897,5 +6841,30 @@
           break;
         }
+
+        if(r_read_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_HEADER;
+          break;
+        }
+
+        if(r_write_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_HEADER;
+          break;
+        }
+
+
         // WRITE
+        if(r_read_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_HEADER;
+          break;
+        }
+
+        if(r_write_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_HEADER;
+          break;
+        }
         if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
@@ -5971,4 +6940,15 @@
         }
         // WRITE
+        if(r_read_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_HEADER;
+          break;
+        }
+
+        if(r_write_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_HEADER;
+          break;
+        }
         if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
@@ -6003,5 +6983,30 @@
           break;
         }
+
+        if(r_read_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_HEADER;
+          break;
+        }
+
+        if(r_write_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_HEADER;
+          break;
+        }
+
+
         // WRITE
+        if(r_read_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_HEADER;
+          break;
+        }
+
+        if(r_write_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_HEADER;
+          break;
+        }
         if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
@@ -6050,4 +7055,18 @@
       case CC_SEND_CAS_IDLE:   // CLEANUP FSM has highest priority
       {
+
+        if(r_read_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_HEADER;
+          break;
+        }
+
+        if(r_write_to_cc_send_req.read())
+        {
+          r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_HEADER;
+          break;
+        }
+
+
         if(m_write_to_cc_send_inst_fifo.rok() or
             r_write_to_cc_send_multi_req.read())
@@ -6208,4 +7227,63 @@
         break;
       }
+
+    case CC_SEND_READ_NCC_INVAL_HEADER:
+      {
+        if(not p_dspin_m2p.read) break;
+
+        r_cc_send_fsm = CC_SEND_READ_NCC_INVAL_NLINE;
+        break;
+      }
+
+    case CC_SEND_READ_NCC_INVAL_NLINE:
+      {
+        if(not p_dspin_m2p.read) break;
+
+        r_read_to_cc_send_req = false;
+        r_cc_send_fsm = CC_SEND_WRITE_IDLE;
+
+#if DEBUG_MEMC_CC_SEND
+        if(m_debug)
+        {
+          std::cout
+            << "  <MEMC " << name()
+            << " CC_SEND_READ_NCC_INVAL_HEADER> Inval for line "
+            << r_read_to_cc_send_nline.read()
+            << std::endl;
+        }
+#endif
+        break;
+      }
+
+
+    case CC_SEND_WRITE_NCC_INVAL_HEADER:
+      {
+        if(not p_dspin_m2p.read) break;
+
+        r_cc_send_fsm = CC_SEND_WRITE_NCC_INVAL_NLINE;
+        break;
+      }
+
+    case CC_SEND_WRITE_NCC_INVAL_NLINE:
+      {
+        if(not p_dspin_m2p.read) break;
+
+        r_write_to_cc_send_req = false;
+        r_cc_send_fsm = CC_SEND_WRITE_IDLE;
+
+#if DEBUG_MEMC_CC_SEND
+        if(m_debug)
+        {
+          std::cout
+            << "  <MEMC " << name()
+            << " CC_SEND_WRITE_NCC_INVAL_HEADER> Inval for line "
+            << r_write_to_cc_send_nline.read()
+            << std::endl;
+        }
+#endif
+        break;
+      }
+
+
       //////////////////////////////////
       case CC_SEND_WRITE_BRDCAST_HEADER:   // send first flit broadcast-inval (from WRITE FSM)
@@ -6417,10 +7495,7 @@
           break;
 
-        assert(not p_dspin_p2m.eop.read() and
-            "VCI_MEM_CACHE ERROR in CC_RECEIVE : "
-            "CLEANUP command must have two flits");
-
         cc_receive_to_cleanup_fifo_put = true;
-        r_cc_receive_fsm               = CC_RECEIVE_CLEANUP_EOP;
+        if(p_dspin_p2m.eop.read())
+          r_cc_receive_fsm               = CC_RECEIVE_IDLE;
 
         break;
@@ -6439,6 +7514,6 @@
 
         cc_receive_to_cleanup_fifo_put = true;
-        r_cc_receive_fsm               = CC_RECEIVE_IDLE;
-
+        if(p_dspin_p2m.eop.read())
+          r_cc_receive_fsm               = CC_RECEIVE_IDLE;
         break;
       }
@@ -6519,5 +7594,9 @@
       }
       else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
-      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_cleanup_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
       else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
       else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
@@ -6535,4 +7614,79 @@
       }
       else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      else if(r_cleanup_to_tgt_rsp_req) 
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      else if(r_read_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_READ;
+        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
+      }
+      break;
+    }
+    ////////////////////////
+    case TGT_RSP_WRITE_IDLE: // cas requests have the highest priority
+    {
+      if(r_cas_to_tgt_rsp_req)            r_tgt_rsp_fsm = TGT_RSP_CAS;
+      else if(r_xram_rsp_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_XRAM;
+        r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
+      }
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      else if(r_cleanup_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
+
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      else if(r_read_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_READ;
+        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
+      }
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      break;
+    }
+    ///////////////////////
+    case TGT_RSP_CAS_IDLE: // xram_rsp requests have the highest priority
+    {
+      if(r_xram_rsp_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_XRAM;
+        r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
+      }
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
+      else if(r_cleanup_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
+      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
+      else if(r_read_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_READ;
+        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
+      }
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      break;
+    }
+    ///////////////////////
+    case TGT_RSP_XRAM_IDLE: // multi ack requests have the highest priority
+    {
+
+      if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
+      else if(r_cleanup_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
       else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
       else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
@@ -6543,10 +7697,6 @@
         r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
       }
-      break;
-    }
-    ////////////////////////
-    case TGT_RSP_WRITE_IDLE: // cas requests have the highest priority
-    {
-      if(r_cas_to_tgt_rsp_req)            r_tgt_rsp_fsm = TGT_RSP_CAS;
+      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
       else if(r_xram_rsp_to_tgt_rsp_req)
       {
@@ -6554,6 +7704,14 @@
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
-      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      break;
+    }
+    ////////////////////////////
+    case TGT_RSP_MULTI_ACK_IDLE: // cleanup requests have the highest priority
+    {
+      if(r_cleanup_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
       else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
       else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
@@ -6564,34 +7722,17 @@
       }
       else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      break;
-    }
-    ///////////////////////
-    case TGT_RSP_CAS_IDLE: // xram_rsp requests have the highest priority
-    {
-      if(r_xram_rsp_to_tgt_rsp_req)
+      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
+      else if(r_xram_rsp_to_tgt_rsp_req)
       {
         r_tgt_rsp_fsm = TGT_RSP_XRAM;
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
-      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
-      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
-      else if(r_read_to_tgt_rsp_req)
-      {
-        r_tgt_rsp_fsm = TGT_RSP_READ;
-        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
-      }
-      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
-      break;
-    }
-    ///////////////////////
-    case TGT_RSP_XRAM_IDLE: // multi ack requests have the highest priority
-    {
-
-      if(r_multi_ack_to_tgt_rsp_req)      r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
-      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
+      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
+      break;
+    }
+    //////////////////////////
+    case TGT_RSP_CLEANUP_IDLE: // tgt cmd requests have the highest priority
+    {
+      if(r_config_to_tgt_rsp_req)         r_tgt_rsp_fsm = TGT_RSP_CONFIG;
       else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
       else if(r_read_to_tgt_rsp_req)
@@ -6607,46 +7748,10 @@
         r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
       }
-      break;
-    }
-    ////////////////////////////
-    case TGT_RSP_MULTI_ACK_IDLE: // cleanup requests have the highest priority
-    {
-      if(r_cleanup_to_tgt_rsp_req)        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
-      else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
-      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
-      else if(r_read_to_tgt_rsp_req)
-      {
-        r_tgt_rsp_fsm = TGT_RSP_READ;
-        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
-      }
-      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
-      else if(r_xram_rsp_to_tgt_rsp_req)
-      {
-        r_tgt_rsp_fsm = TGT_RSP_XRAM;
-        r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
-      }
-      else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK;
-      break;
-    }
-    //////////////////////////
-    case TGT_RSP_CLEANUP_IDLE: // tgt cmd requests have the highest priority
-    {
-      if(r_config_to_tgt_rsp_req)         r_tgt_rsp_fsm = TGT_RSP_CONFIG;
-      else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
-      else if(r_read_to_tgt_rsp_req)
-      {
-        r_tgt_rsp_fsm = TGT_RSP_READ;
-        r_tgt_rsp_cpt = r_read_to_tgt_rsp_word.read();
-      }
-      else if(r_write_to_tgt_rsp_req)     r_tgt_rsp_fsm = TGT_RSP_WRITE;
-      else if(r_cas_to_tgt_rsp_req)       r_tgt_rsp_fsm = TGT_RSP_CAS  ;
-      else if(r_xram_rsp_to_tgt_rsp_req)
-      {
-        r_tgt_rsp_fsm = TGT_RSP_XRAM;
-        r_tgt_rsp_cpt = r_xram_rsp_to_tgt_rsp_word.read();
-      }
       else if(r_multi_ack_to_tgt_rsp_req) r_tgt_rsp_fsm = TGT_RSP_MULTI_ACK   ;
-      else if(r_cleanup_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+      else if(r_cleanup_to_tgt_rsp_req)
+      {
+        r_tgt_rsp_fsm = TGT_RSP_CLEANUP;
+        r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
+      }
       break;
     }
@@ -6716,4 +7821,5 @@
 #endif
 
+
         uint32_t last_word_idx = r_read_to_tgt_rsp_word.read() +
                                  r_read_to_tgt_rsp_length.read() - 1;
@@ -6728,4 +7834,36 @@
           r_read_to_tgt_rsp_req = false;
           r_tgt_rsp_fsm         = TGT_RSP_READ_IDLE;
+          if (r_read_to_tgt_rsp_pktid.read() == 0x0)
+          {
+            m_cpt_read_data_unc ++;
+          }
+          else if (r_read_to_tgt_rsp_pktid.read() == 0x1)
+          {
+            m_cpt_read_data_miss_CC ++;
+          }
+          else if (r_read_to_tgt_rsp_pktid.read() == 0x2)
+          {
+            m_cpt_read_ins_unc ++;
+          }
+          else if (r_read_to_tgt_rsp_pktid.read() == 0x3)
+          {
+            m_cpt_read_ins_miss ++;
+          }
+          else if (r_read_to_tgt_rsp_pktid.read() == 0x6)
+          {
+            m_cpt_read_ll_CC ++;
+          }
+          else if (r_read_to_tgt_rsp_pktid.read() == 0x9)
+          {
+            m_cpt_read_data_miss_NCC ++;
+          }
+          else if (r_read_to_tgt_rsp_pktid.read() == 0x14)
+          {
+            m_cpt_read_ll_NCC ++;
+          }
+          else
+          {
+            m_cpt_read_WTF ++;
+          }
         }
         else
@@ -6768,12 +7906,71 @@
 
 #if DEBUG_MEMC_TGT_RSP
-if(m_debug)
-std::cout << "  <MEMC " << name() << " TGT_RSP_CLEANUP> Cleanup response"
-          << " / rsrcid = " << std::hex << r_cleanup_to_tgt_rsp_srcid.read()
-          << " / rtrdid = " << r_cleanup_to_tgt_rsp_trdid.read()
-          << " / rpktid = " << r_cleanup_to_tgt_rsp_pktid.read() << std::endl;
-#endif
-        r_tgt_rsp_fsm = TGT_RSP_CLEANUP_IDLE;
-        r_cleanup_to_tgt_rsp_req = false;
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " TGT_RSP_CLEANUP> Cleanup response"
+                    << " / rsrcid = " << std::dec << r_cleanup_to_tgt_rsp_srcid.read()
+                    << " / rtrdid = " << r_cleanup_to_tgt_rsp_trdid.read()
+                    << " / rpktid = " << r_cleanup_to_tgt_rsp_pktid.read() << std::endl
+                    << " / data = " << std::hex << r_cleanup_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read() << std::dec << std::endl;
+        }
+#endif
+
+
+        uint32_t last_word_idx = r_cleanup_to_tgt_rsp_first_word.read() + r_cleanup_to_tgt_rsp_length.read() - 1;
+        bool is_ll = ((r_cleanup_to_tgt_rsp_pktid.read() & 0x7) == TYPE_LL);
+
+        if (r_cleanup_to_tgt_rsp_type.read() or ((r_tgt_rsp_cpt.read() == last_word_idx) and not is_ll) or (r_tgt_rsp_key_sent.read() and is_ll) )
+        {
+          r_tgt_rsp_fsm = TGT_RSP_CLEANUP_IDLE;
+          r_cleanup_to_tgt_rsp_req = false;
+          r_tgt_rsp_key_sent = false;
+
+
+          if (r_cleanup_to_tgt_rsp_pktid.read() == 0x0)
+          {
+            m_cpt_read_data_unc ++;
+          }
+          else if (r_cleanup_to_tgt_rsp_pktid.read() == 0x1)
+          {
+            m_cpt_read_data_miss_CC ++;
+          }
+          else if (r_cleanup_to_tgt_rsp_pktid.read() == 0x2)
+          {
+            m_cpt_read_ins_unc ++;
+          }
+          else if (r_cleanup_to_tgt_rsp_pktid.read() == 0x3)
+          {
+            m_cpt_read_ins_miss ++;
+          }
+          else if (r_cleanup_to_tgt_rsp_pktid.read() == 0x6)
+          {
+            m_cpt_read_ll_CC ++;
+          }
+          else if (r_cleanup_to_tgt_rsp_pktid.read() == 0x9)
+          {
+            m_cpt_read_data_miss_NCC ++;
+          }
+          else if (r_cleanup_to_tgt_rsp_pktid.read() == 0x14)
+          {
+            m_cpt_read_ll_NCC ++;
+          }
+          else if (!r_cleanup_to_tgt_rsp_type.read())
+          {
+            m_cpt_read_WTF ++;
+          }
+
+        }
+        else
+        {
+          if (is_ll)
+          {
+            r_tgt_rsp_key_sent = true;
+          }
+          else
+          {
+            r_tgt_rsp_cpt = r_tgt_rsp_cpt.read() + 1;
+          }
+        }
+
       }
       break;
@@ -6825,4 +8022,39 @@
           r_xram_rsp_to_tgt_rsp_req = false;
           r_tgt_rsp_fsm             = TGT_RSP_XRAM_IDLE;
+
+
+          if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x0)
+          {
+            m_cpt_read_data_unc ++;
+          }
+          else if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x1)
+          {
+            m_cpt_read_data_miss_CC ++;
+          }
+          else if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x2)
+          {
+            m_cpt_read_ins_unc ++;
+          }
+          else if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x3)
+          {
+            m_cpt_read_ins_miss ++;
+          }
+          else if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x6)
+          {
+            m_cpt_read_ll_CC ++;
+          }
+          else if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x9)
+          {
+            m_cpt_read_data_miss_NCC ++;
+          }
+          else if (r_xram_rsp_to_tgt_rsp_pktid.read() == 0x14)
+          {
+            m_cpt_read_ll_NCC ++;
+          }
+          else
+          {
+            m_cpt_read_WTF ++;
+          }
+
         }
         else
@@ -6882,4 +8114,7 @@
               else if (r_multi_ack_fsm.read() == MULTI_ACK_UPT_LOCK)
                   r_alloc_upt_fsm = ALLOC_UPT_MULTI_ACK;
+            
+              else
+                  m_cpt_upt_unused++;
           }
           break;
@@ -6894,4 +8129,7 @@
               else if (r_write_fsm.read() == WRITE_UPT_LOCK)
                   r_alloc_upt_fsm = ALLOC_UPT_WRITE;
+            
+              else
+                  m_cpt_upt_unused++;
           }
           break;
@@ -6907,4 +8145,7 @@
               else if (r_cas_fsm.read() == CAS_UPT_LOCK)
                   r_alloc_upt_fsm = ALLOC_UPT_CAS;
+            
+              else
+                  m_cpt_upt_unused++;
           }
           break;
